//******************************************************************************
//! @file $RCSfile: at90canxx_drv.h,v $
//!
//! Copyright (c) 2009 Atmel.
//!
//! ۸т̎gpATMEL̍ŏIgpҋ_񂪕KvłB
//! 쌠ʒmɂĂlicense.txtǂłB
//!
//! @brief ̧قAT90CANxxx޲̖{Iȋ@\ɂĂ̎QƏ^܂B
//!        ̊֐͒۾̂߂̒ڱ񋟂܂B
//!
//! ̧وȉŊmFĂ܂B
//! - AVRStudio 4.15.623,
//! - IAR AVRpC/C++߲ 5.20.1 (5.20.1.50092)
//!
//! @version $Revision: 3.00 $ $Name: jtellier $
//!
//! @todo
//! @bug
//******************************************************************************

#ifndef _AT90CANXX_DRV_H_
#define _AT90CANXX_DRV_H_

//_____ ݸٰ ________________________________________________________________
#include <intrinsics.h>

//_____ ` ___________________________________________________________________
#define SFR_BYTE_AT				*(U8 volatile*)

//_____ 錾 ___________________________________________________________________

//_____ ϸ ____________________________________________________________________
#define Sfr_rd_byte(addr_byte)	( SFR_BYTE_AT(addr_byte) )


//--------------------------------------------------------------------------
//  @fn MACRO-FUNCTION Enable_interrupt
//!
//! SREG(ð ڼ޽)̑S̊荞(I)ޯĂݒ肵܂B
//!
//! @warning	Ȃ
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//-----
//#define Enable_interrupt()	{ asm ("sei") ; }
#define Enable_interrupt()		{ __enable_interrupt(); }		//- {Iȋ@\

//--------------------------------------------------------------------------
//  @fn MACRO-FUNCTION Disable_interrupt
//!
//! SREG(ð ڼ޽)̑S̊荞(I)ޯĂ܂B
//!
//! @warning	Ȃ
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//-----
//#define Disable_interrupt()	{ asm ("cli") ; }
#define Disable_interrupt()		{ __disable_interrupt(); }		//- {Iȋ@\

//--------------------------------------------------------------------------
//  @fn MACRO-FUNCTION Indirect_jump_to
//!
//! ׯ ؂̍ŉ64K(128K޲)֔т܂B
//!
//! @warning:	ҰƂĂ̌ڽ
//!
//! @param:	ڽ(PCZ(15:0))
//!
//! @return	Ȃ
//-----
//#define Indirect_jump_to(jump_addr)	{ GPIOR2=High(jump_addr);    \
										  GPIOR1=Low (jump_addr);    \
										  asm ("lds r31, 0x2B") ;    \
										  asm ("lds r30, 0x2A") ;    \
										  asm ("ijmp");              }

#define Indirect_jump_to(jump_addr)		{ __indirect_jump_to(jump_addr); }	//- {Iȋ@\

//--------------------------------------------------------------------------
//  @fn MACRO-FUNCTION Direct_jump_to_zero
//!
//! ڽ0x0000֔т܂(ؾĂł͂܂!)B
//!
//! @warning:	ؾĂł͂܂!B
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//-----
#define Direct_jump_to_zero()		{ asm ("jmp 0"); }

//#define  Direct_jump_to_zero()	{ __indirect_jump_to(0); }		//- {Iȋ@\

//--------------------------------------------------------------------------
//  @fn MACRO-FUNCTION Hard_reset
//!
//! ޯ ςؾ
//!
//! @warning:	ޯ ςgp܂BBOOTRST˭ސݒ𒲂ׂĂB
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//-----
#define Hard_reset()	{ WDTCR |= 1<<WDE;  while(1); }

//--------------------------------------------------------------------------
//  @fn MACRO-FUNCTION WD_off
//!
//! ޯ ϋ֎~
//!
//! @warning:	ޯ ςgp܂B
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//-----
#define WD_off()	{ MCUSR &= ~(1<<WDRF); WDTCR = (1<<WDCE) | (1<<WDE); WDTCR = 0; }

//--------------------------------------------------------------------------
//  @fn MACRO-FUNCTION WD_reset
//!
//! ꂪ'ON'̎ɳޯ  ؾ(XV)
//!
//! @warning:	ޯ ςgp܂B
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//-----
#define WD_reset()	{ __watchdog_reset(); }		//- {Iȋ@\A{asm("wrd");Ɠ}

//**************************************************************************
#endif // _AT90CANXX_DRV_H_
