//******************************************************************************
//! @file $RCSfile: led_D4_blink.c,v $
//!
//! Copyright (c) 2009 Atmel.
//!
//! ۸т̎gpATMEL̍ŏIgpҋ_񂪕KvłB
//! 쌠ʒmɂĂlicense.txtǂłB
//!
//! @brief: ̉pMC310D4 LEDł̓_łs܂B
//!			_őx͉ϓI̒lɂė^܂B
//!			:	- D4 LEDPC7(25)ɂċ쓮܂B
//!				- ϒRAREF/ISRC(21)ɐڑ܂B
//!
//! ̧وȉŊmFĂ܂B
//! - AVRStudio 4.15.623,
//! - GCC AVRpC/C++߲ (WinAVR-20090313)
//!
//! @version $Revision: 1.00 $ $Name: jtellier $
//!
//! @todo
//! @bug
//******************************************************************************

//_____ A/Dϊϸ ___________________________________________________________
  //! A/DϊON/OFF
#define Adc_enable()					(ADCSRA |=  (1<<ADEN))
#define Adc_disable()					(ADCSRA &= ~(1<<ADEN))
  //! A/DϊOu`Ԑݒ
#define Adc_set_prescaler(prescaler)	(ADCSRA &= ~((1<<ADPS2)|(1<<ADPS1)|(1<<ADPS0)), ADCSRA |= (prescaler))
  //! ʐ`Ԑݒ
#define Adc_left_adjust_result()		(ADMUX |=  (1<<ADLAR))
#define Adc_right_adjust_result()		(ADMUX &= ~(1<<ADLAR))
  //! Vref`Ԑݒ
#define Adc_enable_internal_vref()		(ADMUX |=  ((1<<REFS1)|(1<<REFS0)))
#define Adc_enable_external_vref()		(ADMUX &= ~((1<<REFS1)|(1<<REFS0)))
#define Adc_enable_vcc_vref()			(ADMUX &= ~(1<<REFS1), ADMUX |= (1<<REFS0))
  //! WŕϊJn
#define Adc_clear_mux()					(ADMUX  &= ~((1<<MUX3)|(1<<MUX2)|(1<<MUX1)|(1<<MUX0)) )
#define Adc_select_channel(channel)		(Adc_clear_mux(), ADMUX |= (channel) )
#define Adc_start_conv()				(ADCSRA |= (1<<ADSC) )
#define Adc_start_conv_channel(channel)	(Adc_select_channel(channel),  Adc_start_conv())
  //! ϊԌ
#define Adc_is_conv_finished()			((ADCSRA &  (1<<ADIF)) ? TRUE : FALSE)
#define Adc_is_conv_not_finished()		((ADCSRA | ~(1<<ADIF)) ? TRUE : FALSE)
#define Adc_wait_end_of_conversion()	while (ADCSRA & (1<<ADSC))
  //! nޯĂ̌ʎ擾
#define Adc_get_8_bits_result()			((unsigned char)(ADCH))
#define Adc_get_10_bits_result()		(((unsigned long)ADCL) + ((unsigned long)(ADCH<<8)))

//_____ ݸٰ ________________________________________________________________
#include <avr/io.h>

//_____ ֐ _________________________________________________________________
int main(void)
{
  unsigned long volatile count;

  // ߰ď
  DDRC = 0x80; PORTC = 0x80;
  // A/Dϊ평(ϒR̍ől=Vcc/2)
  Adc_set_prescaler(4);
  Adc_left_adjust_result();
  Adc_enable_vcc_vref();
  Adc_enable();
  while(1)
  {
	PINC = 0x80;
	Adc_start_conv_channel(0xD);
	Adc_wait_end_of_conversion();
	count=((unsigned long)(Adc_get_8_bits_result()))<<9;
	while(count!=0) count--;
  }
  return 0;
}
