//******************************************************************************
//! @file $RCSfile: main_can_boot_loader.c,v $
//!
//! Copyright (c) 2009 Atmel.
//!
//! ۸т̎gpATMEL̍ŏIgpҋ_񂪕KvłB
//! 쌠ʒmɂĂlicense.txtǂłB
//!
//! @brief: ̉pAT90CAN128/64/32ATmega16M1/32M1/32C1/64M1/64C1p̎
//!			ޯđxAIAP(p)AAPI(pݲ̪)tCANް
//!			۰ނs܂B
//!
//! ް ۰ނ(pLq̂悤)ŁAql͂̉pƊƐmɍ
//! ̺ނKvłBqlɉ邢̓Ăяo(܂͕)IAP
//! API̋@\𐳂gƂKvłB
//!
//! ̧ق͈ȉŊmFĂ܂B
//! - AVRStudio 4.15.623,
//! - IAR AVRpC/C++߲ 5.20.1 (5.20.1.50092)
//!
//! @version $Revision: 3.00 $ $Name: jtellier $
//!
//! @todo
//! @bug
//******************************************************************************

//_____ ݸٰ ________________________________________________________________
#include "config.h"
#include "can_isp_protocol.h"
#include "isp_lib.h"
#include "reduced_can_lib.h"
#include "can_drv.h"
#include "flash_boot_lib.h"

//_____ ϸ ____________________________________________________________________

//_____ ` ___________________________________________________________________

//_____ 錾 ___________________________________________________________________

//_____ ֐ ___________________________________________________________________

//******************************************************************************
//  @fn main
//!
//! "main_can_boot_loader.c"̊j
//!
//! @brief: ̉p͎ޯđxAIAP(p)AAPI(pݲ̪)
//!			AT90CAN128/64/32pCANް ۰ނs܂B
//!
//! @warning: ް ۰ނ"ް ۰ ׯ̈"ɊSɔzu邱ƂYȂ
//!			  B
//!			  "board.h"̧قŒ`xxx_HWCB
//!
//! @param none.
//!
//! @return Integer 0
//!
//******************************************************************************
int main (void)
{
  U8      hwcb = FALSE;
  Bool    auto_b = 1;

//! --- SĂ̏߂ƂāAS̊荞݋֎~
  Disable_interrupt();

//! --- ؾĂ痈Ȃ΁Aʰ޳ޯĂ̌
  if (MCUSR != 0)
  {
	// ޯ ؾĂ
	if ((MCUSR & (1<<WDRF)) == (1<<WDRF))
	{
	  //- Ȃ΁Aޯދ֎~(OFF)
	  WD_off();
	  //- Sؾ ׸މ
	  MCUSR = 0;
	  // pJn
	  isp_jump_to( (((U16)SA_H)<<8) | ((U16)SA_L));
	}
	else
	{
	  //- Sؾ ׸މ
	  MCUSR = 0;
	  //- HWCB擾
	  HWCB_PORT_DIR &= ~(1<<HWCB_INPUT_PIN);	// HWCBݓ͐ݒ
	  if (HWCB_PULLUP_ON == 1)
	  {
		HWCB_PORT_OUT |= (1<<HWCB_INPUT_PIN);	// HWCB ٱߐݒ
	  }
	  hwcb = HWCB_PORT_IN;
	  if (HWCB_ACTIVE_LEVEL == 0)
	  {
		hwcb = ((~hwcb)&(1<<HWCB_INPUT_PIN));
	  }

	  //- pJnAȂް ۰ފJn
	  if ( ((BSB!=BSB_DEFAULT)&&(hwcb==0)) || ((BSB==BSB_DEFAULT)&&(hwcb!=0)) )
	  {
		isp_jump_to( (((U16)SA_H)<<8) | ((U16)SA_L));	// pJn
	  }
	  // Ȃ΁Aް ۰ނ
	}
  }

//! --- CANʐMJ

  can_communication_opened = 0;							// CANʐM

  //- ޯ ڽwpTxCANRxCANٱ
  CAN_PORT_DIR &= ~(1<<CAN_INPUT_PIN );
  CAN_PORT_DIR &= ~(1<<CAN_OUTPUT_PIN);
  CAN_PORT_OUT |=  (1<<CAN_INPUT_PIN );
  CAN_PORT_OUT |=  (1<<CAN_OUTPUT_PIN);

  while (1)
  {
	auto_b = ((~auto_b)&0x01);							// "auto_b"ғ

	//- RxCANł̊܂őҋ@
	while ((CAN_PORT_IN & (1<<CAN_INPUT_PIN)) != 0);

	//- CANӋ@\ؾ
	Can_reset();

	//- CANޯ ݸސݒ
	if (EB != 0xFF)
	{
	  CANBT1 = BTC1; CANBT2 = BTC2; CANBT3 = BTC3;
	}
	else
	//- ꂪs܂ŎޯđxJԂ
	{
	  while ((Can_bit_timing(auto_b))==0);				// "can_drv.h"ϸێQ
	}

	//- CANӋ@\
	can_clear_all_mob();								// "can_drv.c"̊֐Q
	Can_enable();										// "can_drv.h"ϸێQ

//! --- CAN ISPKs
	//- CANʐMJĂȂɂCAN ISPK̏
	if(!can_communication_opened) can_isp_protocol_init();

	//- CANʰ޳ُ킪Nꍇɂ"0"Ŕo
	while(can_isp_protocol_task());
  }
}   // End of "main"
