//**************************************************************************
//! @file $RCSfile: reduced_can_lib.c,v $
//!
//! Copyright (c) 2009 Atmel.
//!
//! ۸т̎gpATMEL̍ŏIgpҋ_񂪕KvłB
//! 쌠ʒmɂĂlicense.txtǂłB
//!
//! @brief ̧ق͑SĂATMEL CANAAT90CAN128/64/32ATmega16M1/32M1/32C1/
//!		   64M1/64C1Ɏgp\CANײ ٰ݂܂݂܂B
//!
//! ̧وȉŊmFĂ܂B
//! - AVRStudio 4.15.623,
//! - IAR AVRpC/C++߲ 5.20.1 (5.20.1.50092)
//!
//! @version $Revision: 3.00 $ $Name: jtellier $
//!
//! @todo
//! @bug
//******************************************************************************

//_____ ݸٰ ________________________________________________________________
#include "config.h"
#include "reduced_can_lib.h"
#include "can_drv.h"

//_____ ` ___________________________________________________________________

//_____ ֐ ___________________________________________________________________

//------------------------------------------------------------------------------
//  @fn can_cmd
//!
//! ̊֐͍sׂ(MAMA~)𕪐͂CANLqq܂B
//! ̊֐͑M܂͎MpMObꍇɏ(CAN_CMD_ACCEPTED܂
//! CAN_CMD_REFUSED)Ԃ܂BMObꍇAp͌ōĎsȂ
//! Ȃ܂B
//! ̊֐͑M܂͎MpMObꍇCANLqq(MOB_PENDING
//! MOB_NOT_REACHED)XV܂B~sꂽꍇACANLqqԂ
//! STATUS_CLEAREDɐݒ肳܂B
//!
//! @param	st_cmd_t* - sׂICANLqq\̂Can_descriptor߲
//!
//! @return	CAN_CMD_ACCEPTED - ߂͎󂯓܂B
//!			CAN_CMD_REFUSED  - ߂͋ۂ܂B
//!
//------------------------------------------------------------------------------
U8 can_cmd(st_cmd_t* cmd)
{
  U8  cpt;
  U8  rtn_val;

  rtn_val = CAN_CMD_ACCEPTED;
  cmd->status = MOB_PENDING;

  //------------ "reduced_can_lib.c"p
  if ((cmd->cmd) == CMD_TX_DATA)
  {
	cmd->handle = LAST_MOB_NB;
	Can_set_mob(LAST_MOB_NB);
	Can_clear_mob();
	Can_clear_ide();
	Can_set_std_id(cmd->id.std);
	for (cpt=0; cpt<cmd->dlc; cpt++) CANMSG = *(cmd->pt_data + cpt);
	Can_clear_rtr();
	Can_set_dlc(cmd->dlc);
	Can_config_tx();
  }
  //------------ "reduced_can_lib.c"p
  else if ((cmd->cmd) == CMD_RX_DATA_MASKED)
  {
	cmd->handle = MOB_0;
	Can_set_mob(MOB_0);
	Can_clear_mob();
	Can_clear_ide();
	Can_set_std_id(cmd->id.std);
	Can_set_std_msk(cmd->msk.std);
	Can_set_rtrmsk(); Can_clear_rtr();
	Can_set_idemsk();
	Can_config_rx();
  }
  // CMD_NONE܂͖߂̏ꍇ
  else rtn_val= STATUS_CLEARED;

  return rtn_val;
}

//------------------------------------------------------------------------------
//  @fn can_get_status
//!
//! ̊֐͖߂sꂽۂԂƂ܂B
//! M̏ꍇASĂCANүނ\̂Ɋi[܂B
//! ̊֐CANM(MOB_TX_COMPLETED,MOB_RX_COMPLETED,MOB_RX_COMPLETED_DLCW,
//! MOB_???_ERROR)XV܂B
//!
//! @param	st_cmd_t* CANLqq\߲̂
//!
//! @return	CAN_STATUS_COMPLETED		- M܂͎M͊܂B
//!			CAN_STATUS_NOT_COMPLETED	- M܂͎M͊܂łB
//!			CAN_STATUS_ERROR			- `Ԑݒ܂CANʐMłُ̈
//!
//------------------------------------------------------------------------------
U8 can_get_status (st_cmd_t* cmd)
{
  U8 a_status;
  U8 rtn_val;

  a_status = cmd->status;
  if ( (a_status==STATUS_CLEARED)||(a_status==MOB_NOT_REACHED)||(a_status==MOB_DISABLE) )
  {
	return CAN_STATUS_ERROR;
  }

  Can_set_mob(cmd->handle);
  a_status = can_get_mob_status();

  switch (a_status)
  {
	case MOB_NOT_COMPLETED:
	  // cmd->status͍XV܂B
	  rtn_val = CAN_STATUS_NOT_COMPLETED;
	  break;
	//--------------- "reduced_can_lib.c"p
	case MOB_RX_COMPLETED:
	case MOB_RX_COMPLETED_DLCW:
	  cmd->dlc = Can_get_dlc();
	  can_get_data(cmd->pt_data);
	  // ɕWڰ
	  Can_get_std_id(cmd->id.std);	//- Warning[Pa082]: `̓: j󱸾̎w̍sŖ`ɂ܂B
	  // MȂALqq̏ԗ̈:0x20
	  // DCLxŎMȂALqq̏ԗ̈:0xA0
	  cmd->status = a_status;
	  Can_mob_abort();				// MObJ
	  Can_clear_status_mob();		// MObؾ
	  rtn_val = CAN_STATUS_COMPLETED;
	  break;
	//--------------- "reduced_can_lib.c"p
	case MOB_TX_COMPLETED:
	  // MȂALqq̏ԗ̈:0x40
	  cmd->status = a_status;
	  Can_mob_abort();				// MObJ
	  Can_clear_status_mob();		// MObؾ
	  rtn_val = CAN_STATUS_COMPLETED;
	  break;
	//---------------
	default:
	  // MObُȂALqq̏ԗ̈:(2i)000b.scfa
	  cmd->status = a_status;
	  Can_mob_abort();				// MObJ
	  Can_clear_status_mob();		// MObؾ
	  rtn_val = CAN_STATUS_ERROR;
	  break;
  }
  return (rtn_val);
}
