//******************************************************************************
//! @file $RCSfile: flash_boot_lib.c,v $
//!
//! Copyright (c) 2009 Atmel.
//!
//! ۸т̎gpATMEL̍ŏIgpҋ_񂪕KvłB
//! 쌠ʒmɂĂlicense.txtǂłB
//!
//! @brief ̊֐AT90CAN128/64/32޲ׯ  sٰ݂̑g
//!		   ܂݂܂B
//!
//! ̧وȉŊmFĂ܂B
//! - AVRStudio 4.15.623,
//! - IAR AVRpC/C++߲ 5.20.1 (5.20.1.50092)
//!
//! @version $Revision: 3.00 $ $Name: jtellier $
//!
//! @todo
//! @bug
//******************************************************************************

//_____ ݸٰ ________________________________________________________________
#include "config.h"
#include "flash_boot_lib.h"
#include "flash_boot_drv.h"

//_____ ` ___________________________________________________________________

//_____ ֐ ___________________________________________________________________

//------------------------------------------------------------------------------
//  @fn flash_rd_byte
//!
//! ̊֐ׯ ؂64K޲ēǂݍ݂܂B
//!
//! @warning:	(:RAMPZڼ޽̐ݒ܂͉)̑O64K߰ސݒ肪sȂ
//!				΂Ȃ܂B
//!
//! @param:		addr_byte	ׯ ؂޲Ăǂޱڽ
//!
//! @return:	ׯ ؂œǂ񂾒l
//------------------------------------------------------------------------------
U8 flash_rd_byte(U16 addr_byte)
{
#if defined(_RAMPZ_IS_USED_)
  U32  far_addr_byte;

  far_addr_byte = (((U32)(RAMPZ))<<16) | ((U32)(addr_byte));
  return (Farflash_rd_byte(far_addr_byte));

#else
  return (Stdflash_rd_byte(addr_byte));
#endif	//- If _RAMPZ_IS_USED_ ...

//  return (Flash_rd_byte(addr_word));
}

//------------------------------------------------------------------------------
//  @fn flash_rd_word
//!
//! ̊֐ׯ ؂64KŌǂݍ݂܂B
//!
//! @warning:	1 - ̱ڽ͋޲ ڽłB
//!				2 - (:RAMPZڼ޽̐ݒ܂͉)̑O64K߰ސݒ肪s
//!					΂Ȃ܂B
//!
//! @param:		addr_word	ׯ ؂Ōǂޱڽ
//!
//! @return:	ׯ ؂œǂ񂾒l
//------------------------------------------------------------------------------
U16 flash_rd_word(U16 addr_word)
{
#if defined(_RAMPZ_IS_USED_)
  U32  far_addr_word;

  far_addr_word = (((U32)(RAMPZ))<<16) | ((U32)(addr_word));
  return (Farflash_rd_word(far_addr_word));

#else
  return (Stdflash_rd_word(addr_word));
#endif	//- If _RAMPZ_IS_USED_ ...

//  return (Flash_rd_word(addr_word));
}

//------------------------------------------------------------------------------
//  @fn flash_wr_byte
//!
//! ̊֐ׯ ؂64K޲ď݂܂B
//!
//! @warning:	(:RAMPZڼ޽̐ݒ܂͉)̑O64K߰ސݒ肪sȂ
//!				΂Ȃ܂B
//!
//! @param:		addr_byte	ׯ ؂޲Ăڽ
//!				value		ׯ ؂ɏ߂̒l
//!
//! @return	Ȃ
//------------------------------------------------------------------------------
void flash_wr_byte(U16 addr_byte, U8 value)
{
  flash_wr_block(&value, addr_byte, 1);
}

//------------------------------------------------------------------------------
//  @fn flash_wr_block
//!
//! ̊֐ׯ ؓ65535޲(64K޲-1)܂ł݂̏܂B
//! ̊֐̖͐(޲Ă߰ނ̐)Ǘ܂B
//!
//!-----------------------------------------------------------------------------
//! : ޲Ă͈قȂ߰ł߂ɐpflash_wr_block()  ||
//!		֐łȂ΂Ȃ܂B͐޲Ă̂Ɉȉ̒iKKvȂ  ||
//!		ƂłB															  ||
//!		- Fill_Temporary_Buffer (size=1߰ޒ)								  ||
//!		- Erase_Page														  ||
//!		- Program_Page														  ||
//!		޲Ă֐߰ޓ̏ꍇAProgram_Pagȅꏊŋ󔒌ꂪ擾 ||
//!		߁AErase_PageProgram_pageז܂!!!B					  ||
//!-----------------------------------------------------------------------------
//!
//! @warning:	1 - ̊֐͊S64K޲Ăڽwł܂񂪁A޲ɉ
//!					64K܂ł̓]ɏՕ𓾂邱Ƃł܂B
//!				2 - (:RAMPZڼ޽̐ݒ܂͉)O64K߰ސݒ肪sȂ
//!					΂Ȃ܂B
//!
//! @param:	src		(SRAM)]ɏՕ߲
//!			dest	]AްȂ΂ȂȂׯ ؂̊Jnڽl
//!			byte_nb	޲Đ
//!
//! @return	Ȃ
//------------------------------------------------------------------------------
#pragma location ="API_FLASH"
void flash_wr_block(U8* src, U16 dest, U16 byte_nb)
{
  U8      save_i_flag;
  U16     u16_temp, nb_word;
  U16     address;
  U16     save_page_addr;

  //--- APIp ------------------------
  save_i_flag = SREG;								//- 悸ɑS̊荞݂֎~
  Disable_interrupt();
  address = dest & ~( (U16)(FLASH_PAGE_SIZE-1) );	//- ]߰ނ̊JnڽvZ
  while(byte_nb)									//- ]ɏՕ擾/ݒ肷ްs
  {
	save_page_addr = address;						//- ߰ ڽۑ
	for(nb_word = 0; nb_word < (FLASH_PAGE_SIZE/2); nb_word++)	//- ߰ޓ̊eɑ΂
	{
	  u16_temp = 0x00;								//- ްؾ
	  if(byte_nb)									//- ]擾/ݒ肷ްLȂA
	  {
		if(address >= dest)							//- ݂̱ڽړI͈ͱڽŁA
		{
		  
		  u16_temp |= (U16)(Sram_rd_byte(src));		//- ]ɏՕ̏޲Ď擾(Sram_rd_byte(addr)"flash_boot_drv.h"Œ`)
		  src++; byte_nb--;
		  if(byte_nb)								//- (Ă)擾/ݒް΁A
		  {
			u16_temp |= ((U16)(Sram_rd_byte(src))) << 8;	//- ]ɏՕ̉޲Ď擾(Sram_rd_byte(addr)"flash_boot_drv.h"Œ`)
			src++; byte_nb--;
		  }
		  else										//- ]ɏՕɑƂMSBȂA
		  {
			u16_temp |= ((U16)(flash_rd_byte(address+1))) << 8;		//- ׯ牺޲Ď擾
		  }
		}
		else										//- ݂̌ڽڕW]̊OȂA
		{
		  u16_temp |= (U16)(flash_rd_byte(address));	//- ׯ޲Ď擾
		  if((address+1) == dest)					//- ̉ʱڽ]͈͓ȂA
		  {
			u16_temp |= ((U16)(Sram_rd_byte(src))) << 8;	// (Sram_rd_byte(addr)"flash_boot_drv.h"Œ`)
			src++; byte_nb--;
		  }
		  else										//- ׯ牺޲ēǂݍ
		  {
			u16_temp |= ((U16)(flash_rd_byte(address+1))) << 8;
		  }
		}
	  }
	  else											//- ׯě߰ފ
	  {
		u16_temp = flash_rd_word(address);
	  }
	  flash_fill_temp_buffer(address, u16_temp);
	  address += 2;
	}
	//- ߰ނ󔒂łȂ΂
	//- ͌vI(펞)߰ޏłB
	address = save_page_addr;
	if ( flash_page_blank_check(save_page_addr) != 0 ) flash_page_erase(save_page_addr);
	flash_page_write(save_page_addr);				//- ߰ޏ
	address = save_page_addr + FLASH_PAGE_SIZE;		//- ߰ޗpɍŏׯ ڽXV
  }
  Flash_rww_section_enable;							//- RWWSB׸މҋ@
  Flash_prog_completed;
  //--- APIp ---------------------------
  if(save_i_flag & 0x80) Enable_interrupt();;		//- ݒ肳ĂȂAS̊荞݂ċ
}

//------------------------------------------------------------------------------
//  @fn flash_full_erase
//!
//! ̊֐ׯ ؑŜ܂BRAMPZǗ܂B
//!
//! @warning	Ȃ
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//------------------------------------------------------------------------------
void flash_full_erase(void)

#if defined(_RAMPZ_IS_USED_)
{
  U8  save_rampz;
  U32 page_nb = 0;

  save_rampz = RAMPZ;									//- RAMPZlۑ
  while ( page_nb < ((U32)(MAX_FLASH_SIZE_TO_ERASE)) )
  {
	RAMPZ = ((U8)(page_nb>>16));
	flash_page_erase((U16)(page_nb));
	page_nb += ((U32)(FLASH_PAGE_SIZE));
  }
  Flash_prog_completed;									//- RWWSB׸މҋ@
  RAMPZ = save_rampz;									//- RAMPZl
}

#else
{
  U16 page_nb = 0;

  while ( page_nb < ((U16)(MAX_FLASH_SIZE_TO_ERASE)) )
  {
	flash_page_erase(page_nb);
	page_nb += ((U16)(FLASH_PAGE_SIZE));
  }
  Flash_prog_completed;									//- RWWSB׸މҋ@
}
#endif

//------------------------------------------------------------------------------
//  @fn flash_page_blank_check
//!
//! ̊֐ׯ ؂߰ނ̋󔒌s܂B
//!
//! @warning:	(:RAMPZڼ޽̐ݒ܂͉)O64K߰ސݒ肪sȂ
//!				Ȃ܂B
//!
//! @param:		page_addr	󔒌߰ޔ͈͓̱ڽ
//!
//! @return:	1 - 0000 0000 0000 0000(2i)=߰
//!				2 - 1xxx xxxx xxxx xxxx(2i)=߰ޓ̋󔒂łȂŏ̱ڽ
//!											 (߰ޓ̕ψ)
//------------------------------------------------------------------------------
U16 flash_page_blank_check(U16 page_addr)
{
  U16     u16_temp = 0;
  U16     nb_word;

  page_addr = page_addr & ~((U16)(FLASH_PAGE_SIZE - 1));			//- ߰ ڽ
  //- 󔒌
  for(nb_word = 0; nb_word < (FLASH_PAGE_SIZE/2); nb_word++)
  {
	if( ( flash_rd_word(page_addr) ) != ((U16)(FLASH_BLANK_WORD)) )
	{
	  u16_temp = 0x1000;
	  break;	//- Exit from blank checking 󔒌(for(nb_word...)甲o
	}
	page_addr += 2;
  }
  //- 
  u16_temp = u16_temp |  ( page_addr & ((U16)(FLASH_PAGE_SIZE - 1)) );
  return (u16_temp);
}
