//******************************************************************************
//! @file $RCSfile: flash_boot_lib.c,v $
//!
//! Copyright (c) 2009 Atmel.
//!
//! ۸т̎gpATMEL̍ŏIgpҋ_񂪕KvłB
//! 쌠ʒmɂĂlicense.txtǂłB
//!
//! @brief ̧قAT90CAN128/64/32޲ׯ  ŝ߂̑SĂ̌
//!		   ^ϸۂ܂݂܂B
//!
//! ̧وȉŊmFĂ܂B
//! - AVRStudio 4.15.623,
//! - IAR AVRpC/C++߲ 5.20.1 (5.20.1.50092)
//!
//! @version $Revision: 3.00 $ $Name: jtellier $
//!
//! @todo
//! @bug
//******************************************************************************

#ifndef _FLASH_BOOT_LIB_H_
#define _FLASH_BOOT_LIB_H_

//_____ ݸٰ ________________________________________________________________

#include "config.h"
#include "flash_boot_drv.h"

//_____ ϸ ____________________________________________________________________

//_____ ` ___________________________________________________________________

//_____ 錾 ___________________________________________________________________

//------------------------------------------------------------------------------
//  @fn flash_rd_byte
//!
//! ̊֐ׯ ؂64K޲ēǂݍ݂܂B
//!
//! @warning:	(:RAMPZڼ޽̐ݒ܂͉)̑O64K߰ސݒ肪sȂ
//!				΂Ȃ܂B
//!
//! @param:		addr_byte	ׯ ؂޲Ăǂޱڽ
//!
//! @return:	ׯ ؂œǂ񂾒l
extern U8 flash_rd_byte(U16 addr_byte);

//------------------------------------------------------------------------------
//  @fn flash_rd_word
//!
//! ̊֐ׯ ؂64KŌǂݍ݂܂B
//!
//! @warning:	1 - ̱ڽ͋޲ ڽłB
//!				2 - (:RAMPZڼ޽̐ݒ܂͉)̑O64K߰ސݒ肪s
//!					΂Ȃ܂B
//!
//! @param:		addr_word	ׯ ؂Ōǂޱڽ
//!
//! @return:	ׯ ؂œǂ񂾒l
extern U16 flash_rd_word(U16 addr_word);

 //-----------------------------------------------------------------------------
//  @fn flash_wr_byte
//!
//! ̊֐ׯ ؂64K޲ď݂܂B
//!
//! @warning:	(:RAMPZڼ޽̐ݒ܂͉)̑O64K߰ސݒ肪sȂ
//!				΂Ȃ܂B
//!
//! @param:		addr_byte	ׯ ؂޲Ăڽ
//!				value		ׯ ؂ɏ߂̒l
//!
//! @return	Ȃ
//------------------------------------------------------------------------------
extern void flash_wr_byte(U16 addr_byte, U8 value);

//------------------------------------------------------------------------------
//  @fn flash_wr_block
//!
//! ̊֐ׯ ؓ65535޲(64K޲-1)܂ł݂̏܂B
//! ̊֐̖͐(޲Ă߰ނ̐)Ǘ܂B
//!
//! @warning:	1 - ̊֐͊S64K޲Ăڽwł܂񂪁A޲ɉ
//!					64K܂ł̓]ɏՕ𓾂邱Ƃł܂B
//!				2 - (:RAMPZڼ޽̐ݒ܂͉)O64K߰ސݒ肪sȂ
//!					΂Ȃ܂B
//!
//! @param:	src		(SRAM)]ɏՕ߲
//!			dest	]AްȂ΂ȂȂׯ ؂̊Jnڽl
//!			byte_nb	޲Đ
//!
//! @return	Ȃ
extern void flash_wr_block(U8* src, U16 dest, U16 byte_nb);

//------------------------------------------------------------------------------
//  @fn flash_full_erase
//!
//! ̊֐ׯ ؑŜ܂BRAMPZǗ܂B
//!
//! @warning	Ȃ
//!
//! @param	Ȃ
//!
//! @return	Ȃ
extern void flash_full_erase(void);

//------------------------------------------------------------------------------
//  @fn flash_page_blank_check
//!
//! ̊֐ׯ ؂߰ނ̋󔒌s܂B
//!
//! @warning:	(:RAMPZڼ޽̐ݒ܂͉)O64K߰ސݒ肪sȂ
//!				Ȃ܂B
//!
//! @param:		page_addr	󔒌߰ޔ͈͓̱ڽ
//!
//! @return:	1 - 0000 0000 0000 0000(2i)=߰
//!				2 - 1xxx xxxx xxxx xxxx(2i)=߰ޓ̋󔒂łȂŏ̱ڽ
//!											 (߰ޓ̕ψ)
extern U16 flash_page_blank_check(U16 page_addr);

//******************************************************************************

#endif  // _FLASH_BOOT_LIB_H_
